/* $Id: InvalidAttributeException.java,v 1.2 2006/01/24 17:59:14 greese Exp $ */
/* Copyright 2003-2006 Valtira Corporation, All Rights Reserved */
package org.dasein.attributes;

/**
 * <p>
 *   Represents some kind of error instantiating an attribute or its associated data type.
 * </p>
 * <p>
 *   This class was originally developed for the 
 *   <a href="http://simplicis.valtira.com" title="Simplicis web site">Simplicis Content
 *   Management System</a> in 2003 and moved into an Open Source library in 2006.
 * </p>
 * <p>
 *   Last modified: $Date: 2006/01/24 17:59:14 $
 * </p>
 * @version $Revision: 1.2 $
 * @author George Reese
 */
public class InvalidAttributeException extends RuntimeException {
    /**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 3257001038589277241L;

    /**
     * Constructs a new exception with no error message. Avoid using this meaningless constructor.
     */
	public InvalidAttributeException() {
        super();
    }

    /**
     * Constructs a new exception that describes why it could not manage the attribute in question.
     * @param msg the error message
     */
    public InvalidAttributeException(String msg) {
        super(msg);
    }
}
