package org.dasein.media;

import java.io.Serializable;

public class MimeType implements Serializable {
    static public MimeType valueOf(String str) {
        if( str == null ) {
            return new MimeType("");
        }
        return new MimeType(str);
    }
    
    /**
     * <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = -5980159494976494827L;
    
    private String type    = null;
    private String subtype = null;
    
    public MimeType(String tstring) {
        super();
        {
            String[] parts = tstring.split("/");

            if( parts.length == 1 ) {
                type = parts[0];
            }
            else {
                type = parts[0];
                subtype = parts[1];
            }
        }
    }

    public MimeType(String t, String st) {
        super();
        type = t;
        subtype = st;
    }

    public String getType() {
        return type;
    }

    public String getSubtype() {
        return subtype;
    }
    
    public String toString() {
        return (type + "/" + subtype);
    }
}
