package org.dasein.net.jsp.util;

import java.io.IOException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

import org.dasein.net.jsp.ELParser;
import org.dasein.util.CSVParser;

public class CSVTag extends TagSupport {
    private static final long serialVersionUID = -2239547419306968657L;
    
    private String             fileKey     = null;
    private String             var         = null;
    
    public int doEndTag() throws JspException {
        try {
            String fname = (String)pageContext.findAttribute(fileKey);
            CSVParser parser = new CSVParser(fname);
            
            
            pageContext.setAttribute(var, parser.next());
            return EVAL_PAGE;
        }
        catch( IOException e ) {
            e.printStackTrace();
            throw new JspException(e.getMessage());
        }
        finally {   
            fileKey = null;
            var = null;
        }
    }
    
    public void setFileKey(String fk) throws JspException {
        fileKey = (new ELParser(fk)).getStringValue(pageContext);
    }
    
    public void setVar(String v) {
        var = v;
    }
}
