/* $Id: EnumDisplayTag.java,v 1.1 2006/01/12 17:16:45 greese Exp $ */
/* Copyright (c) 2006 Valtira Corporation, All Rights Reserved */
package org.dasein.net.jsp.util;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

import org.dasein.net.jsp.ELParser;

/**
 * <p>
 *   Provides the result of {@link Enum#toString()} method for the specified enum.
 * </p>
 * <p>
 *   Last modified: $Date: 2006/01/12 17:16:45 $
 * </p>
 * @version $Revision: 1.1 $
 * @author George Reese
 */
public class EnumDisplayTag extends TagSupport {
    /**
     * <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257291344119346487L;
    
    private Enum   value = null;
    private String var       = null;
    
    public int doEndTag() throws JspException {
        try {
            pageContext.setAttribute(var, value.toString());
            return EVAL_PAGE;
        }
        finally {
            value = null;
            var = null;
        }
    }

    
    public void setEnum(String val) throws JspException {
        value = (Enum)(new ELParser(val)).getValue(pageContext);
    }
    
    public void setVar(String v) {
        var = v;
    }
}
