/* $Id: CacheLoader.java,v 1.1 2005/08/15 16:19:34 george Exp $ */
/* Copyright (c) 2005 Valtira Corporation, All Rights Reserved */
package org.dasein.util;

/**
 * <p>
 *   Loads a cached item from its persistent data store. The loader is used by a
 *   {@link ConcurrentCache} to load a value when not present in the cache.
 * </p>
 * <p>
 *   Last modified: $Date: 2005/08/15 16:19:34 $
 * </p>
 * @version $Revision: 1.1 $
 * @author George Reese
 * @param <T> the type of objects being loaded by the cache loader
 */
public interface CacheLoader<T> {
    /**
     * Loads a cached item for the concurrent cache. If the item does not exist,
     * this method should return <code>null</code>.
     * @return a valid item for the cache or <code>null</code>
     */
    public abstract T load(Object ... args);
}
