/* $Id: CacheManagementException.java,v 1.2 2006/01/29 05:50:02 greese Exp $ */
/* Copyright (c) 2005 Valtira Corporation, All Rights Reserved */
package org.dasein.util;

/**
 * <p>
 *   Triggered when requests are made of the cache that don't match the cache
 *   management contract.
 * </p>
 * <p>
 *   Last modified: $Date: 2006/01/29 05:50:02 $
 * </p>
 * @version $Revision: 1.2 $
 * @author George Reese
 */
public class CacheManagementException extends RuntimeException {
    /**
     * <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3256438123063030069L;

    /**
     * Constructs a new exception with the specified error message.
     * @param msg an error message indicating what went wrong
     */
    public CacheManagementException(String msg) {
        super(msg);
    }
    
    /**
     * Constructs a new exception reflecting the underlying cause.
     * @param cause the cause of this exception being thrown
     */
    public CacheManagementException(Throwable cause) {
        super(cause);
    }
}
