package org.dasein.util;

import java.util.concurrent.Executors;
import java.util.concurrent.ThreadFactory;

public class NamedThreadFactory implements ThreadFactory {
    private int    count = 1;
    private String name  = "Unknown";
    
    public NamedThreadFactory(Class owner) {
        this(owner, "");
    }
    
    public NamedThreadFactory(Class owner, String name) {
        this.name = "[" + owner.getName() + "] " + name;
    }
    
    public Thread newThread(Runnable r) {
        ThreadFactory factory = Executors.defaultThreadFactory();
        Thread t;
        
        t = factory.newThread(r);
        t.setName(name + " (" + (count++) + ")");
        return t;
    }
    
}
