package org.dasein.util;

import java.text.SimpleDateFormat;
import java.util.Date;

public class TimePeriod {
    private long endTimestamp;
    private long startTimestamp;
    
    public TimePeriod() { }
    
    public TimePeriod(long startTimestamp, int durationInHours, int durationInMinutes) {
        this.startTimestamp = startTimestamp;
    }
    
    public boolean contains(long when) {
        return ((startTimestamp <= when) && (endTimestamp > when));
    }
    
    public long getEndTimestamp() {
        return endTimestamp;
    }
    
    public long getStartTimestamp() {
        return startTimestamp;
    }
    
    private transient volatile String periodString = null;
    
    public String toString() {
        String ps;
        
        synchronized( this ) {
            ps = periodString;
        }
        if( ps == null ) {
            SimpleDateFormat fmt = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ");
            StringBuilder str = new StringBuilder();
            
            str.append(fmt.format(new Date(startTimestamp)));
            str.append("/");
            str.append(fmt.format(new Date(endTimestamp)));
            ps = str.toString();
            synchronized( this ) {
                periodString = ps;
            }
        }
        return ps;
    }
}
