/* $Id: Translation.java,v 1.2 2007/04/15 11:19:44 greese Exp $ */
/* Copyright © 2003 George Reese, All Rights Reserved */
package org.dasein.util;

import java.io.Serializable;
import java.util.Locale;

/**
 *
 * <br/>
 * Last modified: $Date: 2007/04/15 11:19:44 $
 * @version $Revision: 1.2 $
 * @author George Reese (http://george.reese.name)
 */
public class Translation<T> implements DelegatedComparable, Serializable {
    /**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 3258689922893165368L;
	private T      data    = null;
    private Locale locale  = null;

    public Translation(Locale loc, T dat) {
        super();
        locale = loc;
        data = dat;
    }
    
    public T getData() {
        return data;
    }

    public Object getDelegate(Locale loc) {
        return getData();
    }
    
    public Locale getLocale() {
        return locale;
    }

    public String getString() {
        return data.toString();
    }

    public String toString() {
        if( data == null ) {
            return "<NULL>";
        }
        return data.toString();
    }
}
